<?php

namespace Drupal\Tests\sfc\Kernel;

use Drupal\KernelTests\KernelTestBase;

/**
 * Tests methods provided by the component layout.
 *
 * @coversDefaultClass \Drupal\sfc\Plugin\Layout\ComponentLayout
 *
 * @group sfc
 */
class ComponentLayoutTest extends KernelTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'sfc',
    'sfc_test',
    'layout_discovery',
  ];

  /**
   * Tests the ::build method.
   */
  public function testBuild() {
    /** @var \Drupal\sfc\Plugin\Layout\ComponentLayout $layout */
    $layout = \Drupal::service('plugin.manager.core.layout')->createInstance('single_file_component_layout:say_hello');
    $renderer = \Drupal::service('renderer');
    $build = $layout->build([]);
    $render = $renderer->renderPlain($build);
    $this->assertEquals('<p class="say-hello">Hello !</p>', $render);
    $layout->setConfiguration([
      'component_context' => [
        'name' => 'Sam',
      ],
    ]);
    $build = $layout->build([]);
    $render = $renderer->renderPlain($build);
    $this->assertEquals('<p class="say-hello">Hello Sam!</p>', $render);
  }

}
